# Global Express Thoroughfare

GlobalExpressThoroughfare is a means for retrieving the thoroughfares within a Postal Code using the Postal Code and beginning of the thoroughfare name as the inputs.
The service requires at least one of the follwing input combinations:
**Set A** - `thoroughfare`
**Set B** - `postalcode`

Endpoint: GET /GlobalExpressThoroughfare

## Query parameters:

  - `diacriticreplace` (boolean)
    `True` replaces diacritics in the address. `False` will keep current diacritics in the address results. If left blank, this defaults to `False`.

  - `format` (string)
    Desired format of the response. Possible values are `json`, `jsonp`, or `xml`, depending on the endpoint.
**Note**: the base URL for JavaScript format request is `https://expressentry.melissadata.net/jsonp/`.

  - `id` (string, required)
    Required. The [License Key](https://docs.melissa.com/melissa/license/license-information.html) issued by Melissa.

  - `maxrecords` (number)
    The maximum number of records to return.

  - `country` (string, required)
    Required. The ISO2Code or country name of the address.

  - `postalcode` (string)
    Postal Code, ZIP. The complete postal code.

  - `thoroughfare` (string)
    Street, Thoroughfare. This is used to limit the search to thoroughfares beginning with the specified letters.
This requires a minimum of three characters. For example, mai will return all thoroughfares beginning with mai in the specified postal code.

## Header parameters:

  - `Accept` (string, required)
    Format of the response.

  - `Content-Type` (string, required)
    Format of the request.

## Response 200:

  - `200` (unknown)
    Global Express Locality Administrative Area response

## Response 200 fields (application/json):

  - `Version` (string)
    The current service version number.

  - `ResultCode` (string)
    Lists result codes for the most recent request. For more information, see [Global Express Entry Result Codes](https://docs.melissa.com/cloud-api/global-express-entry/result-codes.html).

  - `ErrorString` (string)
    Lists error codes from any errors caused by the most recent request. For more information, see [Global Express Entry Result Codes](https://docs.melissa.com/cloud-api/global-express-entry/result-codes.html).

  - `Results` (array)
    Array with Address array(s) containing the record level fields.

  - `Results.Address` (object)

  - `Results.Address.Address` (string)
    The full address in one line.

  - `Results.Address.Address1` (string)
    Address line 1.

  - `Results.Address.Address2` (string)
    Address line 2.

  - `Results.Address.Address3` (string)
    Address line 3.

  - `Results.Address.Address4` (string)
    Address line 4.

  - `Results.Address.Address5` (string)
    Address line 5.

  - `Results.Address.Address6` (string)
    Address line 6.

  - `Results.Address.Address7` (string)
    Address line 7.

  - `Results.Address.Address8` (string)
    Address line 8.

  - `Results.Address.Address9` (string)
    Address line 9.

  - `Results.Address.Address10` (string)
    Address line 10.

  - `Results.Address.Address11` (string)
    Address line 11.

  - `Results.Address.Address12` (string)
    Address line 12.

  - `Results.Address.DeliveryAddress` (string)
    The full delivery address in one line.

  - `Results.Address.DeliveryAddress1` (string)
    Delivery address line 1.

  - `Results.Address.DeliveryAddress2` (string)
    Delivery address line 2.

  - `Results.Address.DeliveryAddress3` (string)
    Delivery address line 3.

  - `Results.Address.DeliveryAddress4` (string)
    Delivery address line 4.

  - `Results.Address.DeliveryAddress5` (string)
    Delivery address line 5.

  - `Results.Address.DeliveryAddress6` (string)
    Delivery address line 6.

  - `Results.Address.DeliveryAddress7` (string)
    Delivery address line 7.

  - `Results.Address.DeliveryAddress8` (string)
    Delivery address line 8.

  - `Results.Address.DeliveryAddress9` (string)
    Delivery address line 9.

  - `Results.Address.DeliveryAddress10` (string)
    Delivery address line 10.

  - `Results.Address.DeliveryAddress11` (string)
    Delivery address line 11.

  - `Results.Address.DeliveryAddress12` (string)

  - `Results.Address.CountryName` (string)
    The name of the country.

  - `Results.Address.ISO3166_2` (string)
    The 2 letter ISO 3166 country code value. For example: `US` for United States or `CA` for Canada.

  - `Results.Address.ISO3166_3` (string)
    The 3 letter ISO 3166 country code value. For example: `USA` for United States or `CAN` for Canada.

  - `Results.Address.ISO3166_N` (string)
    The ISO 3166 country number value. For example: `840` for United States or `124` for Canada.

  - `Results.Address.SuperAdministrativeArea` (string)
    A region within a country that has a higher level of administrative control or governance than other areas.

  - `Results.Address.AdministrativeArea` (string)
    State, Province. This is a common geographic area unit for larger countries.

  - `Results.Address.SubAdministrativeArea` (string)
    **County**. A logical area that that is smaller than the administrative area but larger than a locality. Rarely used as part of an official address.

  - `Results.Address.Locality` (string)
    **City, Town**. The most common geographic area, used by virtually all countries.

  - `Results.Address.CityAccepted` (string)
    A list of accepted city names.

  - `Results.Address.CityNotAccepted` (string)
    Any non-accepted city names will be included in this field.

  - `Results.Address.DependentLocality` (string)
    **Urbanization**. A dependent locality is a logical area unit that is smaller than a locality but larger than a double dependent locality or thoroughfare. It can often be associated with a neighborhood or sector.

  - `Results.Address.DoubleDependentLocality` (string)
    A logical area unit that is smaller than a dependent locality but bigger than a thoroughfare. This field is rarely used.

  - `Results.Address.Thoroughfare` (string)
    **Street**. The most common street or block data element.

  - `Results.Address.DependentThoroughfare` (string)
    Dependent Street. A second thoroughfare that is required to narrow down the final address. This is rarely used.

  - `Results.Address.Building` (string)
    A descriptive name identifying an individual location.

  - `Results.Address.Premise` (string)
    **Street Number**. The premise identifying number.

  - `Results.Address.SubBuilding` (string)
    A smaller division of a building. For example, if an address has a building name that is a part of a larger set of buildings, then the sub building may be populated.

  - `Results.Address.PostalCode` (string)
    **ZIP Code**. Complete postal code for a particular delivery point.

  - `Results.Address.PostalCodePrimary` (string)
    The primary portion of the postal code. In the US, this is a 5-digit ZIP code.

  - `Results.Address.PostalCodeSecondary` (string)
    The secondary portion of the postal code. In the US this is the +4 of the ZIP code.

  - `Results.Address.Organization` (string)
    **Business, Company**. This name of the organization.

  - `Results.Address.PostBox` (string)
    Post box information for a particular delivery point.

  - `Results.Address.Unmatched` (string)
    Any part of the address that did not match other fields will be saved in this field.

  - `Results.Address.GeneralDelivery` (string)
    The USPS address type assigned for the address.

  - `Results.Address.DeliveryInstallation` (string)
    **Canada Only**. The delivery installation for the address.

  - `Results.Address.Route` (string)
    **Canada Only**. The route service number.

  - `Results.Address.AdditionalContent` (string)
    Any additional content associated with the address.

  - `Results.Address.CountrySubdivisionCode` (string)
    This is the ISO3166-2 code for country subdivisions, usually the administrative area for a country. The format is the 2 letter country code followed by a dash followed by 2 or 3 characters or two numbers.

  - `Results.Address.MAK` (string)
    Melissa Address Key. A unique key assigned to the submitted address.

  - `Results.Address.BaseMAK` (string)
    Melissa Address Key Base. If the address has suites or apartments the 10 digit proprietary BaseMAK will be returned and correspond to the overall building.

  - `Results.Address.Latitude` (string)
    The latitude geographic coordinate of the output address.

  - `Results.Address.Longitude` (string)
    The longitude geographic coordinate of the output address.

  - `Results.Address.DistanceFromPoint` (integer)
    The distance in miles from the specified point.

## Response 200 fields (application/javascript):

  - `d` (object)

  - `d.__type` (string)

  - `d.Version` (string)
    The current service version number.

  - `d.ResultCode` (string)
    Lists result codes for the most recent request. For more information, see [Global Express Entry Result Codes](https://docs.melissa.com/cloud-api/global-express-entry/result-codes.html).

  - `d.ErrorString` (string)
    Lists error codes from any errors caused by the most recent request. For more information, see [Global Express Entry Result Codes](https://docs.melissa.com/cloud-api/global-express-entry/result-codes.html).

  - `d.Results` (array)
    Array with Address array(s) containing the record level fields.

  - `d.Results.__type` (string)
    Example: ResultGlobal

  - `d.Results.Address` (object)

  - `d.Results.Address.Address` (string)
    The full address in one line.

  - `d.Results.Address.Address1` (string)
    Address line 1.

  - `d.Results.Address.Address2` (string)
    Address line 2.

  - `d.Results.Address.Address3` (string)
    Address line 3.

  - `d.Results.Address.Address4` (string)
    Address line 4.

  - `d.Results.Address.Address5` (string)
    Address line 5.

  - `d.Results.Address.Address6` (string)
    Address line 6.

  - `d.Results.Address.Address7` (string)
    Address line 7.

  - `d.Results.Address.Address8` (string)
    Address line 8.

  - `d.Results.Address.Address9` (string)
    Address line 9.

  - `d.Results.Address.Address10` (string)
    Address line 10.

  - `d.Results.Address.Address11` (string)
    Address line 11.

  - `d.Results.Address.Address12` (string)
    Address line 12.

  - `d.Results.Address.DeliveryAddress` (string)
    The full delivery address in one line.

  - `d.Results.Address.DeliveryAddress1` (string)
    Delivery address line 1.

  - `d.Results.Address.DeliveryAddress2` (string)
    Delivery address line 2.

  - `d.Results.Address.DeliveryAddress3` (string)
    Delivery address line 3.

  - `d.Results.Address.DeliveryAddress4` (string)
    Delivery address line 4.

  - `d.Results.Address.DeliveryAddress5` (string)
    Delivery address line 5.

  - `d.Results.Address.DeliveryAddress6` (string)
    Delivery address line 6.

  - `d.Results.Address.DeliveryAddress7` (string)
    Delivery address line 7.

  - `d.Results.Address.DeliveryAddress8` (string)
    Delivery address line 8.

  - `d.Results.Address.DeliveryAddress9` (string)
    Delivery address line 9.

  - `d.Results.Address.DeliveryAddress10` (string)
    Delivery address line 10.

  - `d.Results.Address.DeliveryAddress11` (string)
    Delivery address line 11.

  - `d.Results.Address.DeliveryAddress12` (string)

  - `d.Results.Address.CountryName` (string)
    The name of the country.

  - `d.Results.Address.ISO3166_2` (string)
    The 2 letter ISO 3166 country code value. For example: `US` for United States or `CA` for Canada.

  - `d.Results.Address.ISO3166_3` (string)
    The 3 letter ISO 3166 country code value. For example: `USA` for United States or `CAN` for Canada.

  - `d.Results.Address.ISO3166_N` (string)
    The ISO 3166 country number value. For example: `840` for United States or `124` for Canada.

  - `d.Results.Address.SuperAdministrativeArea` (string)
    A region within a country that has a higher level of administrative control or governance than other areas.

  - `d.Results.Address.AdministrativeArea` (string)
    State, Province. This is a common geographic area unit for larger countries.

  - `d.Results.Address.SubAdministrativeArea` (string)
    **County**. A logical area that that is smaller than the administrative area but larger than a locality. Rarely used as part of an official address.

  - `d.Results.Address.Locality` (string)
    **City, Town**. The most common geographic area, used by virtually all countries.

  - `d.Results.Address.CityAccepted` (string)
    A list of accepted city names.

  - `d.Results.Address.CityNotAccepted` (string)
    Any non-accepted city names will be included in this field.

  - `d.Results.Address.DependentLocality` (string)
    **Urbanization**. A dependent locality is a logical area unit that is smaller than a locality but larger than a double dependent locality or thoroughfare. It can often be associated with a neighborhood or sector.

  - `d.Results.Address.DoubleDependentLocality` (string)
    A logical area unit that is smaller than a dependent locality but bigger than a thoroughfare. This field is rarely used.

  - `d.Results.Address.Thoroughfare` (string)
    **Street**. The most common street or block data element.

  - `d.Results.Address.DependentThoroughfare` (string)
    Dependent Street. A second thoroughfare that is required to narrow down the final address. This is rarely used.

  - `d.Results.Address.Building` (string)
    A descriptive name identifying an individual location.

  - `d.Results.Address.Premise` (string)
    **Street Number**. The premise identifying number.

  - `d.Results.Address.SubBuilding` (string)
    A smaller division of a building. For example, if an address has a building name that is a part of a larger set of buildings, then the sub building may be populated.

  - `d.Results.Address.PostalCode` (string)
    **ZIP Code**. Complete postal code for a particular delivery point.

  - `d.Results.Address.PostalCodePrimary` (string)
    The primary portion of the postal code. In the US, this is a 5-digit ZIP code.

  - `d.Results.Address.PostalCodeSecondary` (string)
    The secondary portion of the postal code. In the US this is the +4 of the ZIP code.

  - `d.Results.Address.Organization` (string)
    **Business, Company**. This name of the organization.

  - `d.Results.Address.PostBox` (string)
    Post box information for a particular delivery point.

  - `d.Results.Address.Unmatched` (string)
    Any part of the address that did not match other fields will be saved in this field.

  - `d.Results.Address.GeneralDelivery` (string)
    The USPS address type assigned for the address.

  - `d.Results.Address.DeliveryInstallation` (string)
    **Canada Only**. The delivery installation for the address.

  - `d.Results.Address.Route` (string)
    **Canada Only**. The route service number.

  - `d.Results.Address.AdditionalContent` (string)
    Any additional content associated with the address.

  - `d.Results.Address.CountrySubdivisionCode` (string)
    This is the ISO3166-2 code for country subdivisions, usually the administrative area for a country. The format is the 2 letter country code followed by a dash followed by 2 or 3 characters or two numbers.

  - `d.Results.Address.MAK` (string)
    Melissa Address Key. A unique key assigned to the submitted address.

  - `d.Results.Address.BaseMAK` (string)
    Melissa Address Key Base. If the address has suites or apartments the 10 digit proprietary BaseMAK will be returned and correspond to the overall building.

  - `d.Results.Address.Latitude` (string)
    The latitude geographic coordinate of the output address.

  - `d.Results.Address.Longitude` (string)
    The longitude geographic coordinate of the output address.

  - `d.Results.Address.DistanceFromPoint` (integer)
    The distance in miles from the specified point.

## Response 400:

  - `400` (unknown)
    Bad Request

## Response 400 fields (application/json):

  - `type` (string)
    The type of error that occurred.

  - `title` (string)
    A short summary of the error.

  - `status` (integer)
    The HTTP status code for the error.

  - `errors` (object)

  - `errors.$.<PropertyName>` (array)
    A detailed message about the error.

  - `traceId` (string)
    A unique identifier for the request, useful for debugging.

## Response 200 examples:

  - `Default Response` (unknown)

  - `XML Response Example` (unknown)

  - `JavaScript Response Example` (unknown)

